package groowt.gradle.publish

import com.jessebrault.jbarchiva.JbArchivaPlugin
import org.gradle.api.Plugin
import org.gradle.api.Project
import org.gradle.api.publish.maven.plugins.MavenPublishPlugin
import org.gradle.api.credentials.HttpHeaderCredentials
import org.gradle.authentication.http.HttpHeaderAuthentication

class GroowtPublishPlugin implements Plugin<Project> {

    @Override
    void apply(Project project) {
        project.plugins.apply(MavenPublishPlugin)
        project.plugins.apply(JbArchivaPlugin)
        project.with {
            publishing {
                repositories {
                    maven {
                        name = "Gitea"
                        url = uri("https://git.jessebrault.com/api/packages/jessebrault/maven")

                        credentials(HttpHeaderCredentials) {
                            name = "Authorization"
                            value = "token ${System.getenv("GITEA_ACCESS_TOKEN")}"
                        }

                        authentication {
                            header(HttpHeaderAuthentication)
                        }
                    }
                }
            }
        }
    }

}
